Subject: Re: bug#43831: Only when compiled: Wrong number of arguments

From: Jan Nieuwenhuizen <[email-masked]>
Date: Wed, 07 Oct 2020 10:30:08 +0200

Jan Nieuwenhuizen writes:

Hello again,

> Running mescc with compiled guile-3.0.4 (guile-3.0-latest on guix
> master) code gives
>
>     Wrong number of arguments to #<procedure expr->register (o info)>
>
> Using guile-2.2, or running without compiling is fine.
>
> To reproduce, do

[..]

> I'm aware that this isn't exactly a "minimal reprocucing
> example"...however I've no idea to get there.

I found a way to bisect it into something much smaller; see attached.

To reproduce, do:

--8<---------------cut here---------------start------------->8---
$ guix environment --ad-hoc [email-masked]
10:27:13 janneke@dundal:~/tmp/bug [env]
$ guile --no-auto-compile -C . -e '(wrong-number-of-arguments)' wrong-number-of-arguments.scm 
Hello MesCC
10:27:18 janneke@dundal:~/tmp/bug [env]
$ guild compile -o wrong-number-of-arguments.go wrong-number-of-arguments.scm
;;; note: auto-compilation is enabled, set GUILE_AUTO_COMPILE=0
;;;       or pass the --no-auto-compile argument to disable.
;;; compiling /gnu/store/yxwq48xmimjsy2b6s6ga8mcfs47af936-profile/bin/guild
;;; compiled /home/janneke/.cache/guile/ccache/3.0-LE-8-4.3/gnu/store/ah16zr8mmfkqy23rr7jy5a842ca1q9h1-guile-3.0.4/bin/guild.go
wrote `wrong-number-of-arguments.go'
10:27:28 janneke@dundal:~/tmp/bug [env]
$ guile -C . -e '(wrong-number-of-arguments)' wrong-number-of-arguments.scm 
;;; note: auto-compilation is enabled, set GUILE_AUTO_COMPILE=0
;;;       or pass the --no-auto-compile argument to disable.
;;; compiling /home/janneke/tmp/bug/wrong-number-of-arguments.scm
;;; compiled /home/janneke/.cache/guile/ccache/3.0-LE-8-4.3/home/janneke/tmp/bug/wrong-number-of-arguments.scm.go
Hello MesCC
Backtrace:
In ice-9/boot-9.scm:
  1736:10  5 (with-exception-handler _ _ #:unwind? _ #:unwind-for-type _)
In unknown file:
           4 (apply-smob/0 #<thunk 7ffb62d6b4a0>)
In ice-9/boot-9.scm:
    718:2  3 (call-with-prompt _ _ #<procedure default-prompt-handler (k proc)>)
In ice-9/eval.scm:
    619:8  2 (_ #(#(#<directory (guile-user) 7ffb629a6f00>)))
In srfi/srfi-1.scm:
   501:18  1 (fold-right #<procedure expr->register (o info)> _ _ . _)
In /home/janneke/tmp/bug/wrong-number-of-arguments.scm:
     24:0  0 (expr->register _ _)

/home/janneke/tmp/bug/wrong-number-of-arguments.scm:24:0: In procedure expr->register:
Wrong number of arguments to #<procedure expr->register (o info)>
[1]10:27:41 janneke@dundal:~/tmp/bug [env]
$ 
--8<---------------cut here---------------end--------------->8---

Greetings,
Janneke

-- 
Jan Nieuwenhuizen <[email-masked]> | GNU LilyPond http://lilypond.org
Freelance IT http://JoyofSource.com | Avatar® http://AvatarAcademy.com